/*
Interactions

`Interactions are managed by our flow designer in UI, what you can control via api is how you start and run interaction flow for contact sending events.  Interaction can start in a multiple ways:  - EntryPont - when contact scans QR code ar opens entry point link  - event as trigger - this way you can start flow for single contact  ## Events Events are a data structure related to some contact action. You can use them whenever you want to start active interaction for contact but also inside interaction flow you can define points wher system should wait for custom event sent from your side.   Depending on your use case our predefined interactions might have defined events and instruction what events should be sent.  Events can be sent directly using our REST Api or triggered automatically by our integration modules.  ## Adding attributes to events Adding attributest to event can personalize communication, select branch flow based on attribute value or use them as perameters in other interaction flow actions. Use `body` property in event structure to add key-value attributes. 

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package interactions

import (
	"encoding/json"
)

// checks if the CxTemplateInstallationTriggersCustomDataInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &CxTemplateInstallationTriggersCustomDataInner{}

// CxTemplateInstallationTriggersCustomDataInner struct for CxTemplateInstallationTriggersCustomDataInner
type CxTemplateInstallationTriggersCustomDataInner struct {
	InteractionId *string `json:"interaction_id,omitempty"`
	Campaign *Campaign `json:"campaign,omitempty"`
}

// NewCxTemplateInstallationTriggersCustomDataInner instantiates a new CxTemplateInstallationTriggersCustomDataInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCxTemplateInstallationTriggersCustomDataInner() *CxTemplateInstallationTriggersCustomDataInner {
	this := CxTemplateInstallationTriggersCustomDataInner{}
	return &this
}

// NewCxTemplateInstallationTriggersCustomDataInnerWithDefaults instantiates a new CxTemplateInstallationTriggersCustomDataInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCxTemplateInstallationTriggersCustomDataInnerWithDefaults() *CxTemplateInstallationTriggersCustomDataInner {
	this := CxTemplateInstallationTriggersCustomDataInner{}
	return &this
}

// GetInteractionId returns the InteractionId field value if set, zero value otherwise.
func (o *CxTemplateInstallationTriggersCustomDataInner) GetInteractionId() string {
	if o == nil || IsNil(o.InteractionId) {
		var ret string
		return ret
	}
	return *o.InteractionId
}

// GetInteractionIdOk returns a tuple with the InteractionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationTriggersCustomDataInner) GetInteractionIdOk() (*string, bool) {
	if o == nil || IsNil(o.InteractionId) {
		return nil, false
	}
	return o.InteractionId, true
}

// HasInteractionId returns a boolean if a field has been set.
func (o *CxTemplateInstallationTriggersCustomDataInner) HasInteractionId() bool {
	if o != nil && !IsNil(o.InteractionId) {
		return true
	}

	return false
}

// SetInteractionId gets a reference to the given string and assigns it to the InteractionId field.
func (o *CxTemplateInstallationTriggersCustomDataInner) SetInteractionId(v string) {
	o.InteractionId = &v
}

// GetCampaign returns the Campaign field value if set, zero value otherwise.
func (o *CxTemplateInstallationTriggersCustomDataInner) GetCampaign() Campaign {
	if o == nil || IsNil(o.Campaign) {
		var ret Campaign
		return ret
	}
	return *o.Campaign
}

// GetCampaignOk returns a tuple with the Campaign field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *CxTemplateInstallationTriggersCustomDataInner) GetCampaignOk() (*Campaign, bool) {
	if o == nil || IsNil(o.Campaign) {
		return nil, false
	}
	return o.Campaign, true
}

// HasCampaign returns a boolean if a field has been set.
func (o *CxTemplateInstallationTriggersCustomDataInner) HasCampaign() bool {
	if o != nil && !IsNil(o.Campaign) {
		return true
	}

	return false
}

// SetCampaign gets a reference to the given Campaign and assigns it to the Campaign field.
func (o *CxTemplateInstallationTriggersCustomDataInner) SetCampaign(v Campaign) {
	o.Campaign = &v
}

func (o CxTemplateInstallationTriggersCustomDataInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o CxTemplateInstallationTriggersCustomDataInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.InteractionId) {
		toSerialize["interaction_id"] = o.InteractionId
	}
	if !IsNil(o.Campaign) {
		toSerialize["campaign"] = o.Campaign
	}
	return toSerialize, nil
}

type NullableCxTemplateInstallationTriggersCustomDataInner struct {
	value *CxTemplateInstallationTriggersCustomDataInner
	isSet bool
}

func (v NullableCxTemplateInstallationTriggersCustomDataInner) Get() *CxTemplateInstallationTriggersCustomDataInner {
	return v.value
}

func (v *NullableCxTemplateInstallationTriggersCustomDataInner) Set(val *CxTemplateInstallationTriggersCustomDataInner) {
	v.value = val
	v.isSet = true
}

func (v NullableCxTemplateInstallationTriggersCustomDataInner) IsSet() bool {
	return v.isSet
}

func (v *NullableCxTemplateInstallationTriggersCustomDataInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCxTemplateInstallationTriggersCustomDataInner(val *CxTemplateInstallationTriggersCustomDataInner) *NullableCxTemplateInstallationTriggersCustomDataInner {
	return &NullableCxTemplateInstallationTriggersCustomDataInner{value: val, isSet: true}
}

func (v NullableCxTemplateInstallationTriggersCustomDataInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCxTemplateInstallationTriggersCustomDataInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


